import java.awt.*;
import java.awt.event.*;

class Alert extends Dialog implements ActionListener{
	private Button btnOK;
	private Button btnCancel;
	private Label lblUser;
	private Label lblClef;
	private TextField tfUser;
	private TextField tfClef;
	private TextArea taDatas;

/*
	public Alert(String msg){
		new Alert(msg,"Fenetre de message");
	}
*/
	public Alert(String msg, String titre){
		super(new Frame(), titre, true);

		Panel panel = new Panel();
		panel.setLayout(null);

		taDatas = new TextArea(msg,10,10,java.awt.TextArea.SCROLLBARS_VERTICAL_ONLY );
		taDatas.setEditable(false);
		taDatas.setBounds(2,2,390,100);
		panel.add(taDatas);

		btnOK = new Button("OK");
		btnOK.setBounds(120,105,145,20);
		btnOK.addActionListener(this);
		panel.add(btnOK);

		add(panel);
		setSize(400, 170);
		show();
	}

	public void actionPerformed(ActionEvent actionevent){
		Object obj = actionevent.getSource();
		if(obj == btnOK){
			hide();
		}
	}

}
