import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.util.EventObject;
import md5;
import RC4;
import Base64;
import Alert;

public class chiffre extends Applet implements ActionListener{

	private String chaine;
	private Button btnChiffrer;
	private Button btnDechiffrer;
	private TextArea taMessage;
	private TextField tfCle;

	public void init(){

		btnChiffrer = new Button("Chiffrer");
		btnDechiffrer = new Button("Dchiffrer");
		taMessage = new TextArea("", 10, 10, 1);
		tfCle = new TextField();
		setLayout(null);
		taMessage.setBounds(5, 5, 600, 175);
		tfCle.setBounds(180, 182, 425, 20);
		btnChiffrer.setBounds(5, 205, 148, 20);
		btnDechiffrer.setBounds(158, 205, 147, 20);
		add(taMessage);
		add(tfCle);
		add(btnChiffrer);
		add(btnDechiffrer);

		//setBackground(new Color(51, 204, 255));
		tfCle.setEchoChar('*');
		btnChiffrer.addActionListener(this);
		btnDechiffrer.addActionListener(this);
	}

	public void paint(Graphics g){
		g.setColor(Color.black);
		g.drawString("Cl de chiffrement / dchiffrement : ", 5, 195);
		g.drawString("(c)2002 Antoine CANONNE", 450, 220);
		g.setColor(Color.red);
		g.drawRect(1, 1, 608, 228);
	}

    public void actionPerformed(ActionEvent actionevent){
        Object obj = actionevent.getSource();
        if(obj == btnChiffrer){
            byte[] key = (tfCle.getText()).getBytes();
            byte[] msg = (taMessage.getText() + md5.hash(taMessage.getText().getBytes())).getBytes();
		byte[] res = msg;
		RC4 algo = new RC4(key);
		
		algo.Initialize();
		algo.Update(msg, res);
		algo.Finalize();
		msg = Base64.encode(res);

		taMessage.setText(new String(msg));
		taMessage.append("\n\n--\nPour dchiffrer ce message\nhttp://www.canonne.net/rc4.html");
        } else
        if(obj == btnDechiffrer){
            byte[] key = (tfCle.getText()).getBytes();
		byte[] msg = Base64.decode((taMessage.getText()).getBytes());
		byte[] res = msg;
		RC4 algo = new RC4(key);
		
		algo.Initialize();
		algo.Update(msg, res);
		algo.Finalize();
		
		String hash = (new String(res)).substring(res.length-32,res.length);
		if (hash.equals(md5.hash((new String(res)).substring(0,msg.length-32).getBytes())))
			taMessage.setText((new String(res)).substring(0,msg.length-32));
		else
			new Alert("Mot de passe non valide\nou message corrompu","Attention");
        }
    }

}
