import java.awt.*;
import java.awt.event.*;

class Modif extends Dialog implements ActionListener{
	private Button btnOK;
	private Button btnCancel;
	private Button btnClear;
	private Label lblUser;
	private Label lblClef;
	private TextField tfUser;
	private TextField tfClef;
	private porteClefs pc;
	private String user;

	public Modif(porteClefs pc,String user){

		super(new Frame(), "Cration / Modification de clef", true);

		this.pc = pc;
		this.user = user;

		Panel panel = new Panel();
		panel.setLayout(null);

		lblUser = new Label("Utilisteur");
		lblUser.setBounds(5,0,50,20);
		panel.add(lblUser);

		tfUser = new TextField();
		tfUser.setBounds(55,0,340,20);
		panel.add(tfUser);

		lblClef = new Label("Clef");
		lblClef.setBounds(5,20,50,20);
		panel.add(lblClef);

		tfClef = new TextField();
		tfClef.setBounds(55,20,340,20);
		panel.add(tfClef);

		btnOK = new Button("OK");
		btnOK.setBounds(5,42,135,20);
		panel.add(btnOK);
		btnOK.addActionListener(this);

		btnCancel = new Button("Annuler");
		btnCancel.setBounds(140,42,145,20);
		panel.add(btnCancel);
		btnCancel.addActionListener(this);
	
		btnClear = new Button("Supprimer");
		btnClear.setBounds(285,42,145,20);
		btnClear.setEnabled(false);
		panel.add(btnClear);
		btnClear.addActionListener(this);


		if(!user.equals("")){
			tfUser.setText(user);
			tfUser.setEditable(false);
			tfClef.setText((String)pc.KeyRing.get(user));
			btnClear.setEnabled(true);
		}

		add(panel);
		setSize(400, 110);
		show();
	}

	public void actionPerformed(ActionEvent actionevent){
		Object obj = actionevent.getSource();
		if(obj == btnCancel){
			hide();
		} else if(obj == btnOK){
			if(user.equals("")){
				pc.chUtilisateurs.add(tfUser.getText());
				pc.KeyRing.put(tfUser.getText(),tfClef.getText());
				hide();
			} else {
				pc.KeyRing.put(tfUser.getText(),tfClef.getText());
				hide();
			}
		} else if(obj == btnClear){
				pc.chUtilisateurs.remove(tfUser.getText());
				pc.KeyRing.remove(tfUser.getText());
				hide();
		}

	}

}
